var download = require("./download_release.js");
var dfu = require("./dfu.js");
var EE = require("events").EventEmitter;
var keytar = require('keytar-fallback');

var getDeviceFirmwares = (link, count) => new Promise((resolve, reject) => {
  count = count || 0;
  if (!link.script) return reject(new Error("DFU chan requires script chan"))
  return link.script("report()")
             .then((res) => link.script("report()"))
             .then(result => {
               var report = JSON.parse(result.result || result)
               console.log(report, result)
               if (!report.tap && count < 3){
                 setTimeout(() => getDeviceFirmwares(link, count++).then((r) => resolve(r)), 2000)
               } else {
                 resolve({
                   patchos : report.build,
                   foible_application : report.ble ? report.ble.build : undefined,
                   tapos : report.tap
                 })
               }
             })

})

const getFirmware = (opts) => {
  return download.get_dfu(opts.decrypt_key, opts)
}

const DFU = module.exports = (opts) => (Mesh, th) => {
  console.log("CHAN DFU", opts);
  process.env.AWS_ACCESS_KEY_ID = opts.access_key_id || process.env.AWS_ACCESS_KEY_ID;
  process.env.AWS_SECRET_ACCESS_KEY = opts.secret_access_key || process.env.AWS_ACCESS_KEY_ID;

  //var firmwarePromise = getFirmware(opts);

  Mesh.firmware = {
    getIndex : () => new Promise((res,rej) => download.get_index((err, ind) => err ? rej(err) : res(ind))),
    getFirmware : getFirmware
  }

  Mesh.on('link',link => {
    var dfu_emitter = new EE();
    link.id = link.hashname.substr(0,8);

    link.currentFirmwares = () => getDeviceFirmwares(link);

    link.dfu = (job, onProgress) => {
      console.log("link.dfu", job)
      let zipname = `tap-${job.desired.id.split("-")[1]}.zip`;
      console.log(zipname)
      return download.get_dfu(keytar.getPassword("filament-hq",zipname) || opts.decryptkey || process.env.FILAMENT_DECRYPT_KEY, opts, zipname)
                     .then((target) => {
                       onProgress = onProgress || (() => {})
                       var k = job.env;
                       var total = Math.ceil(target[k].binary.length / 1024);
                       var sent = 0;
                       return dfu[k](link, target[k].binary, () => {
                         onProgress({
                           total : total,
                           sent : sent++,
                           id : link.hashname.substr(0,8),
                           current : job.reported.id,
                           target : target[k].version,
                           app : k
                         })
                       })
                     })
                     .catch(e => {
                       console.log("ERRR",e);
                     })
    }

    /*link.checkFirmware = () => link.uptodate ? Promise.resolve(true) :
    /*
    Promise.all([firmwarePromise, getDeviceFirmwares(link)])
        .then((to_compare) =>  {
          var target = to_compare[0]
            , device = to_compare[1];
          console.log("DFU COMPARISON", target, device)
          return !Object.keys(device).filter(k => k != "foible_application").some(k => {
            if (device[k] != target[k].version){
              link.dfu = (onProgress) => {
                onProgress = onProgress || (() => {})
                return link.script("init('');keepalive(10)")
                    .then(() => new Promise((res,rej) => {
                      link.once("up", () => setTimeout(res,500))
                    }))
                    .then(() => {
                      var total = Math.ceil(target[k].binary.length / 1024);
                      var sent = 0;
                      return dfu[k](link, target[k].binary, () => {
                        onProgress({
                          total : total,
                          sent : sent++,
                          id : link.hashname.substr(0,8),
                          current : device[k],
                          target : target[k].version,
                          app : k
                        })
                      })
                    })
                    .then(() => new Promise((res,rej) => {
                      link.once('up', () => res())
                    }))
              }
              link.emit('upgrade_needed', {
                current : device[k],
                target : target[k].version,
                id : link.hashname.substr(0,8),
                app : k
              })
              return true;
            }
          });
        }).then(uptodate => new Promise((res,rej) => {
          if (!uptodate) return res(uptodate);
          link.uptodate = uptodate;
          link.once('up',() => {
            console.log(link.id, "is ",!uptodate ? "not" : "","up to date");
            res(uptodate)
          });
          link.console('keepalive(5)',() => {});
        })).catch(e => console.log(e))

    link.dfuFull = (onProgress) => link.checkFirmware().then(uptodate => uptodate ? uptodate : link.dfu(onProgress).then(() => link.dfuFull(onProgress)))
*/
  })
  return {};
}
