var core = require("thc");
var fs = require("fs-jetpack");
var path = require("path");
var ground = core(function(){
 console.log("ground up");
 ground.firmware.getFirmwares.then((res) => {
   console.log("GOT FIRMWARES",res);
 })
},{})
/**
 * Don't hard-code your credentials!
 * Export the following environment variables instead:
 *
 * export AWS_ACCESS_KEY_ID='AKID'
 * export AWS_SECRET_ACCESS_KEY='SECRET'
 * export AWS_S3_REGION='us-west-2'
 */
ground.use(require("./index.js")({}));
ground.use(require("telehash-transport-serial-host-node")({}));

ground.on('link', (link) =>{
  console.log("link up")
  link.checkFirmware();

  link.on('upgrade_needed', (data) => {
    console.log("device upgrade needed",data);
    var dfu = link.dfu()
    dfu.on('progress',(evt) => {
      console.log(evt);
    })

    dfu.on('done',() => {
      console.log("dfu done")
    })

    dfu.on('error',(e) => {
      console.error(e);
    })
  })
})


ground.start(true);
